from handler import handler
import pygame
import random
import resourcer
import config

class bala:
	def __init__(self, color): 
		self.image = resourcer.load('img/bullet/' + color + '.png')
		self.image_m = resourcer.load('img/bullet/' + color + 'm.png')
		self.color = color
		
	def get_color(self):
		return self.color

class ammo_handler(handler):
	def __init__(self):
		self.clip = []
		self.sound_reload = resourcer.load('sound/reload.ogg')
		self.sound_discard = resourcer.load('sound/lostbullet.ogg')
		for i in range(0,3):
			self.add()
		self.remaining = 0
		
	
	def add(self):#agrega una nueva
		self.sound_reload.play()
		self.clip.append(bala(random.choice(['red', 'blue', 'green'])))
	
	def discard(self): #saca la bala actual
		self.clip = []
		self.sound_discard.play()
		self.remaining = config.WAIT_SHOOT_TIME
		return "reload"
		
	def current_color(self):
		if not self.clip:
			return "none"
		return self.clip[0].get_color()
	
	def set_golden(self):
		self.clip = [bala('golden') for i in range(3)]
	
	def draw(self, surface):
		if len(self.clip) == 2:
			surface.blit(self.clip[0].image_m,(880,640))
			surface.blit(self.clip[1].image_m,(853,640))
		else:
			if len(self.clip) == 3:
				surface.blit(self.clip[0].image,(933,540))
				surface.blit(self.clip[1].image_m,(880,640))
				surface.blit(self.clip[2].image_m,(853,640))
	
	def timer(self, ticks):
		if self.remaining > 0:
			self.remaining -= ticks
			if self.remaining < 0:
				self.remaining = 0
				while len(self.clip) < 3:
					self.add()
	
	def events(self, events):
		for event in events:
			if pygame.mouse.get_pressed()[0] and self.remaining == 0:
				self.clip.remove(self.clip[0]) #borra la primera
				self.remaining = config.WAIT_SHOOT_TIME
				return "shoot"
			if pygame.mouse.get_pressed()[2] == True:
				return self.discard()
				