import pygame

class animated_sprite(pygame.sprite.Sprite):
	def __init__(self, images, fps = 10):
		pygame.sprite.Sprite.__init__(self)
		self._images = images
		
		# Track the time we started, and the time between updates.
		# Then we can figure out when we have to switch the image.
		self._start = pygame.time.get_ticks()
		self._delay = 1000.0 / fps
		self._last_update = 0
		self._frame = 0
		self._ticked = 0
		self.rect = images[0].get_rect()
		self.image = self._images[0]
		self._still = False

	def still(self, what):
		self._still = what

	def update(self, t):
		# Note that this doesn't work if it's been more that self._delay
		# time between calls to update(); we only update the image once
		# then, but it really should be updated twice.
		if self._still is False:
			self._ticked += t
			if self._ticked > self._delay:
				self._frame += 1
				if self._frame >= len(self._images): self._frame = 0
				self.image = self._images[self._frame]
				self._ticked = 0
				self._last_update = t
