class vector:
	def __init__(self, x=0, y=0):
		self.x = x
		self.y = y
	
	def add(self, duple):
		self.x = self.x + duple[0]
		self.y = self.y + duple[1]
		return self
	
	def as_duple(self):
		return (self.x, self.y)
	
	def by_scalar(self, scalar):
		return (self.x * scalar, self.y * scalar)
	
	def set_pos(self, pos):
		x, y = pos
		return self

class bounded_vector(vector):
	def add(self, duple):
		vector.add(self, duple)
		self.bound()
		return self
	
	def set_pos(self, pos):
		vector.add(self, pos)
		self.bound()
		return self

class radial_bounded(bounded_vector):
	def __init__(self, boundary=0, x=0, y=0):
		self.x = x
		self.y = y
		self.boundary = boundary
		self.bb = boundary*boundary
	
	def bound(self):
		r = self.x*self.x + self.y*self.y
		if r > self.bb:
			self.x = self.x*self.bb/r
			self.y = self.y*self.bb/r
		return self

class rect_bounded(bounded_vector):
	def __init__(self, x_boundary, y_boundary, x=0, y=0):
		self.x_boundary, self.y_boundary = x_boundary, y_boundary
		self.x, self.y = x, y
	
	def bound(self):
		self.x = max(min(self.x, self.x_boundary[1]), self.x_boundary[0])
		self.y = max(min(self.y, self.y_boundary[1]), self.y_boundary[0])
		return self