from random import *
import pygame
import math

WIDTH = 300
HEIGHT = 400

class Onda:
	def __init__(self, color=None, radius=0):
		if not color:
			color = (randrange(255), randrange(255), randrange(255))
		self.color = color
		self.radius = radius
	
	def __str__(self):
		return "Onda de radio "+str(self.radius)+";"
	
	def elapsed(self, time):
		self.radius += time / 10;
	
	def draw(self, surface):
		pygame.draw.circle(surface, self.color, (WIDTH/2, HEIGHT/2), self.radius)

def mainloop():
	screen = pygame.display.set_mode((WIDTH, HEIGHT))#, pygame.FULLSCREEN)
	font = pygame.font.Font(pygame.font.match_font('dejavuserif'), 30)
	timer = pygame.time.Clock()
	accum = 0
	ondas = [Onda(radius=400), Onda(radius=300), Onda(radius=200), Onda(radius=100), Onda(radius=0)]
	imagenes = []
	mira = (WIDTH/2, HEIGHT/2)
	acel = (0,0)
	last = 0
	condition = True
	while condition:
		for event in pygame.event.get():
			if event.type == pygame.KEYDOWN:
				pass
				#condition = False
		elaps = timer.tick()
		accum += elaps
		if accum > last + 1000:
			ondas.append(Onda())
			last = accum
		screen.fill((0,0,0))
		for onda in ondas:
			onda.elapsed(elaps)
			onda.draw(screen)
			if onda.radius > WIDTH*2:
				ondas.remove(onda)
		#screen.blit(font.render(str(1000.0/float(elaps+1)), True, (255,255,255)), (0,0))
		pygame.display.flip()

if __name__ == '__main__':
	pygame.init()
	mainloop()
