import pygame
import resourcer
import config
import menues
import highscores

from handler import hud_handler, game_background_handler
from enemy_handler import enemy_handler
from mouse_handler import mouse_handler
from smoke_handler import smoke_handler
from ammo_handler import ammo_handler

def game_loop(callback, screen):
	pygame.mixer.music.load('sound/ingame.ogg')
	pygame.mixer.music.play(-1)
	layer = pygame.Surface((config.WIDTH, config.HEIGHT))
	the_font = pygame.font.Font(pygame.font.match_font('dejavuserif'), 30)
	timer = pygame.time.Clock()
	
	# Handlers Initialization
	gh = game_background_handler()
	hh = hud_handler()
	mh = mouse_handler((501, 672), resourcer.load('img/hud.png').get_height())
	eh = enemy_handler((300, 450))
	ah = ammo_handler()
	sh = smoke_handler()
	
	handlers = [gh, eh, hh, mh, ah, sh] # jajajajaajajaj no se de que me rio
	while True:
		elaps = timer.tick()
		events = pygame.event.get()
		return_messages = []
		bullet_color = ah.current_color()
		
		for handler in handlers:
			handler.timer(elaps)
			return_messages.append(handler.events(events))
		
		if "shoot" in return_messages: #mira si esta disparando y no cambio
			got = eh.check_collition(mh.position.as_duple())
			for shot in got:
				if shot['color'] == 'golden':
					ah.set_golden()
			sh.process_shot(got, bullet_color)
			hh.process_shot(got, bullet_color)
		if "pause_signal" in return_messages:
			a_surf = pygame.Surface(screen.get_size())
			a_surf.blit(screen, (0,0))
			menues.pause(dir, screen, a_surf)
		if "exit_signal" in return_messages:
			hh.score = -1
			break
		if "color_wins" in return_messages:
			menues.color_wins(dir, screen)
			break
		if "black_wins" in return_messages:
			menues.black_wins(dir, screen)
			break
		
		for handler in handlers:
			handler.draw(layer)
		
		if config.DEBUG:
			# Print FPS
			layer.blit(the_font.render(str(1000.0/float(elaps+1)), True, resourcer.color['white']), (0,0))
		
		screen.blit(layer, (0,0))
		pygame.display.flip()
	pygame.mixer.music.stop()
	pygame.mouse.set_visible(True)
	
	if hh.score != -1: # -1 means quiter
		if highscores.is_highscore(hh.score):
			menues.new_highscore(dir, screen, hh.score)
		menues.high_scores(dir, screen)
	callback()