from utils import contained_in
from scene import *
from game_loop import game_loop
import config

import menues


class main_menu(scene):
	def __init__(self, callback, surface):
		self.surfaces = [
			resourcer.load('img/main_menu.png'),
		]
		self.tutorialed = False
		self.music = resourcer.load('sound/MenuTotal.ogg')
		self.music.play()
		scene.__init__(self, callback, surface)
	
	def mouse_click(self, pos):
		if contained_in(pos, (365, 333), (323, 50)):
			self.music.stop()
			menues.new_game(dir, self.surface)
			if not self.tutorialed:
				self.tutorialed = True
				menues.tutorial(dir, self.surface)
			game_loop(self.loop, self.surface)
			self.music.play()
			
		if contained_in(pos, (339, 398), (375, 50)):
			menues.high_scores(self.loop, self.surface)
			
		if contained_in(pos, (451, 458), (154, 50)):
			self.music.stop()
			self.callback()
	
	def key_pressed(self, keycode):
		if keycode == pygame.K_q:
			self.callback()
		if keycode == pygame.K_ESCAPE:
			self.callback()