from handler import handler
import bounded_vector
import config
import pygame
import resourcer

class mouse_handler(handler):
	def __init__(self, eye_center, hud_height):
		self.eye_center = bounded_vector.vector(eye_center[0], eye_center[1])
		self.img_crosshair = resourcer.load('img/crosshair.png')
		self.position = bounded_vector.rect_bounded(
			(0, config.WIDTH), (0, config.HEIGHT-hud_height),
			eye_center[0], config.HEIGHT/2)
		self.position.bound()
		self.velocity = bounded_vector.radial_bounded(60.0)
		pygame.mouse.set_visible(False)
		pygame.event.get()
	
	def timer(self, ticks):
		pass
		#self.velocity.set_pos(self.velocity.by_scalar(0.3))
		#self.position.add(self.velocity.by_scalar(float(ticks)/1000.0))
	
	def events(self, events):
		for event in events:
			if event.type == pygame.MOUSEMOTION:
				self.position.add(event.rel)
		return {'position': self.position.as_duple()}
	
	def draw(self, surface):
		surface.blit(self.img_crosshair,
			(self.position.x - self.img_crosshair.get_width()/2,
			self.position.y - self.img_crosshair.get_height()/2) )
		#pygame.draw.line(surface, resourcer.color['red'],
		#	self.eye_center.as_duple(),
		#	(self.eye_center.x + self.velocity.x,
		#	self.eye_center.y + self.velocity.y), 3)
