import random
from config import *
import resourcer

def contained_in((x, y), pos, size):
	'''Checks if '(x, y)' is inside the rect located in 'pos' and with size
	'size' '''
	if x > pos[0] and x < pos[0] + size[0]:
		if y > pos[1] and y < pos[1] + size[1]:
			return True
	return False 


def contained_in_alpha((x, y), image, pos):
	'''Checks if '(x, y)' is inside the 'image' located in 'pos' '''
	if x > pos[0] and x < pos[0] + image.rect[2]:
		if y > pos[1] and y < pos[1] + image.rect[3]:
			try:
				if image.image.get_at((int(x-pos[0]), int(y-pos[1])))[3] > 200: #un pixel
					return True
			except IndexError:
				return False
			else:
				return False
	return False 

def get_random_enemy():
	'''Files in the folder enemies must be:
		* alphabetically sorted
		* of the form letter+number+'.png' with 1 <= number <= Frames
		!! very important -> * in the secuence blue, green, red
	'''
	rand = random.randrange(NUMBER_OF_ENEMIES)
	color = ['blue', 'green', 'red'][rand%3]
	letra = chr(rand + 97)
	lista = []
	i = 1
	while True:
		try:
			next = resourcer.load('img/enemies/' + letra + str(i) + '.png')
			lista.append(next)
			i = i + 1
		except RuntimeError:
			break
	return (lista, color)

def get_golden_enemy():
	'''Files in the folder enemies must be:
		* alphabetically sorted
		* of the form letter+number+'.png' with 1 <= number <= Frames
		!! very important -> * in the secuence blue, green, red
	'''
	color = 'golden'
	lista = []
	i = 1
	while True:
		try:
			next = resourcer.load('img/enemies/golden' + str(i) + '.png')
			lista.append(next)
			i = i + 1
		except RuntimeError:
			break
	rever = lista[1:-1]
	rever.reverse()
	lista.extend(rever)
	return (lista, color)
